
// linux-like acyclic list (DLL with NULL ends)
// uses pointer arithmetic to get list node data, version2 - pointer data

#include <stdlib.h>             // malloc, free, NULL
#include <stddef.h>             // offsetof

/**
 * list_entry - get the pointer to data struct for this entry
 * @ptr:        the &struct list_link pointer.
 * @type:       the type of the data struct the link is embedded in.
 * @member:     the name of the link field within the struct.
 */
#define list_entry(ptr, type, member) ({                        \
        const typeof( ((type *)0)->member ) *__mptr = (ptr);    \
        (type *)( (char *)__mptr - offsetof(type,member) );})

// link to embed in any struct with data
struct list_link {
    struct list_link *next;
    struct list_link *prev;
};

struct list2 {
    struct list2 * succ;
    int data;
};

#define create(first) {			\
    (first) = NULL;			\
     struct list2 *p = malloc(sizeof(struct list2));	\
     p->succ = (first);		\
     p->data = 0;			\
     (first) = p;			\
}

// data struct
struct Node {
    int d;
    struct list_link link;
    char c;
    struct list2 *l2;
};

int main()
{
    struct list_link *h = NULL;
    struct list_link *t = NULL;
    struct list_link *p;
    struct Node *node;
    int i;
    for (i = 1; i < 10; ++i) {
        node = (struct Node *) malloc(sizeof(struct Node));
        p = &(node->link);
        if (NULL == h) {
        p->next = NULL;
            p->prev = NULL;
            h = p;
        } else {
        p->next = NULL;
            p->prev = t;
            t->next = p;
        }
        t = p;
        node->d = 10;
        node->l2=NULL;
        if(i%2) create(node->l2);
    }
    for (p = h; p != NULL; p = p->next) {
        node = list_entry(p, struct Node, link);
        node->d = 20;
    }
    p = h;
    while (p != NULL) {
        node = list_entry(p, struct Node, link);
        struct list2 *p2=node->l2;
        p = p->next;
        if (p != NULL) {
            p->prev = NULL;
        }
        free((void *) node);
        free((void*) p2);
    }
    h = t = NULL;
    return 0;
}
