// The benchmark tests independence of particular C structure used for
// construction of DLL elements. In particular, we have two syntactically
// different C structures N1 and N2 which are both used for construction
// (i.e. allocation) of regions of a single DLL. Although N1 and N2 use
// different names for next and prev pointers, our technique should be
// able to detect the construction of a single DLL.
#include <stdlib.h>
typedef struct SN1
{
    int i1;
    struct SN1 * f1;
    struct SN1 * b1;
} N1;
typedef struct SN2
{
    int i2;
    struct SN2 * f2;
    struct SN2 * b2;
} N2;
int main()
{
    int i = 0;
    N1 *h1 = 0;
    N1 *t1 = 0;
    for ( ; i < 4; ++i)
    {
        if (i%2 == 0)
        {
            N1 * p = (N1*)malloc(sizeof(N1));
            p->i1 = 100;
            p->f1 = 0;
            if (t1 == 0)
            {
                p->b1 = 0;
                h1 = p;
            }
            else
            {
                p->b1 = t1;
                t1->f1 = p;
            }
            t1 = p;
        }
        else
        {
            N2 * h2 = (N2*)h1;
            N2 * t2 = (N2*)t1;
            N2 * p = (N2*)malloc(sizeof(N2));
            p->i2 = 200;
            p->f2 = 0;
            if (t2 == 0)
            {
                p->b2 = 0;
                h2 = p;
            }
            else
            {
                p->b2 = t2;
                t2->f2 = p;
            }
            t2 = p;
            h1 = (N1*)h2;
            t1 = (N1*)t2;
        }
    }
    // MEMORY LEAK (BUT WE DO NOT CARE AS WE ONLY FOCUS ON THE CREATION!)
    return h1 != 0;
}

