
// fill sorted list, search for position, insert, check if sorted
// contains memory leak: no list deleting

#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

struct list_item {
    struct list_item *next;
    struct list_item *prev;
    int data;
};

struct list {
    struct list_item *head;
    struct list_item *tail;
};

void ERROR()
{
    puts("ERROR");
    exit(1);
}

#define list_add(p_l,p_data) \
{                                                               \
    struct list *l = (p_l);                                     \
    int data = (p_data);                                        \
    /*printf("LIST%p ADD %d\n",l,data);*/                       \
    struct list_item *p = malloc(sizeof(struct list_item));     \
    p->next = NULL;                                             \
    p->data = data;                                             \
    if (l->tail) {                                              \
        p->prev = l->tail;                                      \
        l->tail->next = p;                                      \
        l->tail = p;                                            \
    } else {                                                    \
        p->prev = NULL;                                         \
        l->head = p;                                            \
        l->tail = p;                                            \
    }                                                           \
} 

int main()
{
    struct list l1 = { NULL, NULL };

    // list fill -- WARNING: should be sorted
    int i;
    for(i=10;i<20;++i) {
        list_add(&l1, i);
    }

    int ins = __VERIFIER_nondet_int();
    // add ins to sorted list
    //printf("LIST%p INSERT %d\n",&l1,ins);
    // SEARCH:
    struct list_item *it = l1.head;
    while (it != NULL) {
        int d = it->data;
        if (d > ins)
            break;
        it = it->next;
    }
    // INSERT:
    if (it == NULL) {
        // push_back
        list_add(&l1, ins);
    } else {
        // insert before it
        struct list_item *p = malloc(sizeof(struct list_item));
        p->prev = it->prev;     // <--I
        it->prev = p;           //    I<--
        if (it==l1.head)        // insert before first item
            l1.head = p;        // adjust head
        else
            p->prev->next = p;  // -->I
        p->next = it;           //    I-->
        p->data = ins;
    }
    // CHECK_IF_SORTED_LIST:
    it = l1.head;
    if (it == NULL) return 0;
    while (it->next != NULL) {
        int element1 = it->data;
        int element2 = it->next->data;

        if ( ! (element1 <= element2) )
            ERROR();
        it = it->next;
    }

    list_add(&l1, 1000); // add sentinel

    return it==NULL;
}

