
// simple push_back 4 lines code permutation generator
// use C++11

#include <algorithm>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <fstream>
using namespace std;

void gen() {

    for(int i=1; i <= 24; ++i) {
        ostringstream ss;
        ss << "push_back_" << setw(2) << setfill('0') << i << ".c";
        ofstream f(ss.str());

        f << R"(
// pop_back
// One of many possible variants of the classic pop_back operation.
// DLL creation by push_back.
#include <stdlib.h>

typedef struct ListNode {

)";

    //////////////////////////////////////////////////////////////////
    // what to permute:

    static vector<string> v = {
        "int data;",
        "struct ListNode *next;",
        "struct ListNode *prev;",
        "char cdata;",
    };

        for(string s: v)
            f << "        " << s << "\n";

        next_permutation(v.begin(),v.end());
    //////////////////////////////////////////////////////////////////

        f << R"(
} Node;

int main()
{
    // init
    Node *h = NULL;
    Node *t = NULL;
    // create list
    int i = 0;
    for ( ; i < 100; ++i) {
        Node *p = (Node*)malloc(sizeof(Node));
        p->data = 0;
        if (h == NULL) h = p; else t->next = p;
        p->next = NULL;
        p->prev = t;
        t = p;
    }
    // delete list
    while (t != NULL) {
        Node *p = t->prev;
        free((void*)t);
        if (p == NULL) {
            h = NULL;
            t = NULL;
        } else {
            t = p;
            p->next = 0;
        }
    }
    return h != 0;
}
)";

    } // for

}

int main() {
    gen();
}
